# coding: utf-8

"""
    FastAPI

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DataUser(BaseModel):
    """
    DataUser
    """ # noqa: E501
    id: StrictStr = Field(alias="_id")
    username: StrictStr
    username_source: StrictStr
    provider_id: StrictStr
    user_id: Optional[List[StrictStr]] = None
    relationships: Optional[List[StrictStr]] = None
    password: Optional[StrictStr] = None
    role: Optional[StrictStr] = 'user'
    public_key: Optional[StrictStr] = None
    create_ts: datetime
    modify_ts: datetime
    __properties: ClassVar[List[str]] = ["_id", "username", "username_source", "provider_id", "user_id", "relationships", "password", "role", "public_key", "create_ts", "modify_ts"]

    @field_validator('username_source')
    def username_source_validate_enum(cls, value):
        """Validates the enum"""
        if value not in set(['cua', 'sram', 'local']):
            raise ValueError("must be one of enum values ('cua', 'sram', 'local')")
        return value

    @field_validator('role')
    def role_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['user', 'admin', 'provider', 'reviewer']):
            raise ValueError("must be one of enum values ('user', 'admin', 'provider', 'reviewer')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DataUser from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if public_key (nullable) is None
        # and model_fields_set contains the field
        if self.public_key is None and "public_key" in self.model_fields_set:
            _dict['public_key'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DataUser from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "_id": obj.get("_id"),
            "username": obj.get("username"),
            "username_source": obj.get("username_source"),
            "provider_id": obj.get("provider_id"),
            "user_id": obj.get("user_id"),
            "relationships": obj.get("relationships"),
            "password": obj.get("password"),
            "role": obj.get("role") if obj.get("role") is not None else 'user',
            "public_key": obj.get("public_key"),
            "create_ts": obj.get("create_ts"),
            "modify_ts": obj.get("modify_ts")
        })
        return _obj


